/******************************************************

MegaChat

manually chat with a megaspark. The reason you cant
to it with a regular program is because the data
returned is in binary, not ascii format.
which you'll already know if your reading this.

this code is origionally for talking to a solar-cell
  controller. Use it to test your communications
  protocols.

Jul 12 2003  Dan Williams

******************************************************/

#include "serial.h"
#include <dos.h>
#include <conio.h>
#include <stdio.h>
// #include <string.h>
// #include <fstream.h>
#define VERSION 0x0102

#define FALSE           0
#define TRUE            1

#define NOERROR         0       /* No error               */
#define BUFOVFL         1       /* Buffer overflow      */
#define SENDERR         2       /* character transmission error */

#define ESC             0x1B    /* ASCII Escape character */
#define ASCII           0x007F  /* Mask ASCII characters  */
#define SBUFSIZ         0x4000  /* Serial buffer size     */

#define INITPING        0
#define PING            1
#define LISTEN          2
#define IGNORE          3
#define POWERUP         4
#define POWERDOWN       5
#define SETPOSITION     6
#define GETPOSITION     7
#define GETMODEL        15


void mainMenu(void) ;
void menu1(void) ;
void menu2(void) ;
void menu3(void) ;
void menu6(void) ;
void menu7(void) ;
void menu8(void) ;
void sendCommand(unsigned int command, unsigned int argument);
void cls(void) ;


extern int  SError;
       int   done ;



main(){
      /* Communications parameters */

  int port      = COM1;
  int speed     = 9600;
  int parity    = NO_PARITY;
  int bits      = 8;
  int stopbits  = 1;

  int c;


  done = FALSE;

  if (SetSerial(port, speed, parity, bits, stopbits) != 0) {
      printf("Prepare to begin debugging, serial port setup error.\n");
      return (-1);
  }

  initserial();

  ctrlbrk(c_break);


  do {
/*
          if (SerialOut(c) == (-1)) {
             SError = SENDERR;
          }


      if ( (c = getccb()) != (-1) ){  // get the serial character


      }
*/

 mainMenu();

  } while ( !done && !SError );


   // Why did we exit?
  switch (SError) {
      case NOERROR:
         printf("\nClient Terminated... or did you hit escape? ah well, I'm outahere.\n");
         closeserial();
         return (0);
      case BUFOVFL:
         printf("\nAgh fooie!, buffer overflow.\n");
         closeserial();
         return (-1);
      case SENDERR:
         printf("\nGrrr can't send data!!!\n");
         closeserial();
         return (-1);
      default:
         printf("\nWa? Unknown Error, SError = %d\n", SError);
         closeserial();
         return (-1);
  }
}



void mainMenu(void) {

  int choice;

  choice = -1;
 while(choice != 9)  {
  choice = -1;
  while ((choice < 1) || (choice > 9)) {
    cls();
    printf("\n\
  1) AutoDetect servos\n\
  2) Call servo to attention\n\
  3) Dismiss servo\n\
  4) Power up\n\
  5) Power down\n\
  6) Set position\n\
  7) Get position\n\
  8) Get device model\n\
  9) Exit.\n\
  ");
  
  scanf("%d", &choice);
  
  }
  
  switch (choice) {
    case 1:  // autodetect servos
      menu1();
    break;
    
    case 2:  // call servo to attention
      menu2();
    break;
    
    case 3: // dismiss servo
      menu3();
    break;
    
    case 4: // power up
      sendCommand(POWERUP, 0);
    break;
    
    case 5: // power down
      sendCommand(POWERDOWN, 0);
    break;
    
    case 6: // set position
      menu6();
    break;

    case 7: // get position
      menu7();
    break;

    case 8: // get device model
      menu8();
    break;

    case 9:
      done=1;
    break;
  }

 }


}


void menu1(void) { // auto detect servos
  return;
}

void menu2(void) { // call servo to attention

  int argument;

  argument = -1;
  while ((argument < 0) || (argument > 256)){
   cls();
   printf("Which servo would you like to call on? (256 for all)  ");
   scanf("%d", &argument);
  }
  sendCommand(LISTEN, argument);
  return;
}


void menu3(void) { // dismiss servo

  int argument;

  argument = -1;
  while ((argument < 0) || (argument > 256)) {
   cls();
   printf("Which servo would you like to call off? (256 for all)  ");
   scanf("%d", &argument);
  }
  sendCommand(IGNORE, argument);
  return;
}

void menu6(void) { // set servo position

  int argument;

  argument = -1;
  while ((argument < 0) || (argument > 1025)){
   cls();
   printf("What position? (0 to 1024) ");
   scanf("%d", &argument);
  }
  sendCommand(SETPOSITION, argument);
  return;
}

void menu7(void) { // get position
  return;
}

void menu8(void) { // get model
  return;
}


void sendCommand(unsigned int command, unsigned int argument){

   unsigned char data[2];

   data[0] = (command << 3) | (argument & 0x07);
   data[1] = (argument >> 3 ) | 0x80;

    if (SerialOut(data[0]) == (-1)) {
	     SError = SENDERR;
    }
    if (SerialOut(data[1]) == (-1)) {
	     SError = SENDERR;
    }

}


void cls(void) {
  clrscr();
  printf("                  Servo controller                    \n\n");

}
